package space.rocketnine.gophast;

import android.content.Context;
import android.text.format.Formatter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ProgressBar;
import android.widget.TextView;

import java.util.ArrayList;

public class DownloadAdapter extends BaseAdapter {
    private Context context; //context
    private ArrayList<Download> items; //data source of the list adapter

    //public constructor
    public DownloadAdapter(Context context, ArrayList<Download> items) {
        this.context = context;
        this.items = items;
    }

    @Override
    public int getCount() {
        return items.size(); //returns total of items in the list
    }

    @Override
    public Object getItem(int position) {
        return items.get(position); //returns list item at the specified position
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        // inflate the layout for each list row
        if (convertView == null) {
            convertView = LayoutInflater.from(context).
                    inflate(R.layout.list_downloads, parent, false);
        }

        // get current item to be displayed
        Download d = (Download) getItem(position);

        // get the TextView for item name and item description
        TextView downloadName = (TextView)
                convertView.findViewById(R.id.downloadName);
        TextView downloadSize = (TextView)
                convertView.findViewById(R.id.downloadSize);
        TextView downloadURL = (TextView)
                convertView.findViewById(R.id.downloadURL);
        ProgressBar downloadProgress = (ProgressBar)
                convertView.findViewById(R.id.downloadProgress);

        //sets the text for item name and item description from the current item object
        downloadName.setText(d.Name);
        downloadSize.setText(Formatter.formatShortFileSize(context, d.Size));
        downloadURL.setText(d.URL);

        downloadProgress.setMax(1000);
        downloadProgress.setProgress((int)(d.Downloaded * 1000.0 / d.Size));

        // returns the view for the current row
        return convertView;
    }
}